## ros-rolling-sdformat-urdf 0.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(sdformat_urdf)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic -Wnon-virtual-dtor -Woverloaded-virtual)
endif()

find_package(ament_cmake_ros REQUIRED)

find_package(pluginlib REQUIRED)
find_package(rcutils REQUIRED)
find_package(sdformat9 REQUIRED)
find_package(urdfdom_headers REQUIRED)
find_package(urdf_parser_plugin REQUIRED)
find_package(tinyxml2_vendor REQUIRED)
find_package(TinyXML2 REQUIRED)

# Add sdformat_urdf shared library
add_library(sdformat_urdf SHARED
  src/sdformat_urdf.cpp
)
target_link_libraries(sdformat_urdf PUBLIC
    sdformat9::sdformat9
)
target_link_libraries(sdformat_urdf PRIVATE
  rcutils::rcutils
)
target_include_directories(sdformat_urdf
  PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
    "$<INSTALL_INTERFACE:include>"
    ${urdfdom_headers_INCLUDE_DIRS}
)

# Add sdformat_urdf_plugin module library
add_library(sdformat_urdf_plugin MODULE
  src/sdformat_urdf_plugin.cpp
)
target_link_libraries(sdformat_urdf_plugin PRIVATE
  pluginlib::pluginlib
  rcutils::rcutils
  sdformat_urdf
  tinyxml2::tinyxml2
  urdf_parser_plugin::urdf_parser_plugin
)

ament_export_dependencies(urdfdom_headers)
ament_export_dependencies(sdformat9)

install(TARGETS sdformat_urdf EXPORT sdformat_urdf-export
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)
install(TARGETS sdformat_urdf_plugin
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(
  DIRECTORY include/
  DESTINATION include
)

ament_export_targets(sdformat_urdf-export HAS_LIBRARY_TARGET)

pluginlib_export_plugin_description_file(urdf_parser_plugin "sdformat_urdf_plugin.xml")

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(sdformat_test_files 0.1 REQUIRED)
  ament_lint_auto_find_test_dependencies()

  sdformat_test_files_get_model_sdf("path_to_sdf_geometry_box" "geometry_box")
  sdformat_test_files_get_model_sdf("path_to_sdf_geometry_cylinder" "geometry_cylinder")
  sdformat_test_files_get_model_sdf("path_to_sdf_geometry_heightmap" "geometry_heightmap")
  sdformat_test_files_get_model_sdf("path_to_sdf_geometry_mesh_collada" "geometry_mesh_collada")
  sdformat_test_files_get_model_sdf("path_to_sdf_geometry_mesh_obj" "geometry_mesh_obj")
  sdformat_test_files_get_model_sdf("path_to_sdf_geometry_mesh_scaled" "geometry_mesh_scaled")
  sdformat_test_files_get_model_sdf("path_to_sdf_geometry_mesh_stl" "geometry_mesh_stl")
  sdformat_test_files_get_model_sdf("path_to_sdf_geometry_plane" "geometry_plane")
  sdformat_test_files_get_model_sdf("path_to_sdf_geometry_sphere" "geometry_sphere")
  sdformat_test_files_get_model_sdf("path_to_sdf_graph_chain" "graph_chain")
  sdformat_test_files_get_model_sdf("path_to_sdf_graph_chain_non_canonical_root" "graph_chain_non_canonical_root")
  sdformat_test_files_get_model_sdf("path_to_sdf_graph_four_bar" "graph_four_bar")
  sdformat_test_files_get_model_sdf("path_to_sdf_graph_loop" "graph_loop")
  sdformat_test_files_get_model_sdf("path_to_sdf_graph_tree" "graph_tree")
  sdformat_test_files_get_model_sdf("path_to_sdf_graph_tree_non_canonical_root" "graph_tree_non_canonical_root")
  sdformat_test_files_get_model_sdf("path_to_sdf_joint_ball" "joint_ball")
  sdformat_test_files_get_model_sdf("path_to_sdf_joint_continuous" "joint_continuous")
  sdformat_test_files_get_model_sdf("path_to_sdf_joint_fixed" "joint_fixed")
  sdformat_test_files_get_model_sdf("path_to_sdf_joint_gearbox" "joint_gearbox")
  sdformat_test_files_get_model_sdf("path_to_sdf_joint_prismatic" "joint_prismatic")
  sdformat_test_files_get_model_sdf("path_to_sdf_joint_revolute" "joint_revolute")
  sdformat_test_files_get_model_sdf("path_to_sdf_joint_revolute2" "joint_revolute2")
  sdformat_test_files_get_model_sdf("path_to_sdf_joint_revolute_axis" "joint_revolute_axis")
  sdformat_test_files_get_model_sdf("path_to_sdf_joint_revolute_axis_in_frame" "joint_revolute_axis_in_frame")
  sdformat_test_files_get_model_sdf("path_to_sdf_joint_revolute_default_limits" "joint_revolute_default_limits")
  sdformat_test_files_get_model_sdf("path_to_sdf_joint_revolute_two_joints_two_links" "joint_revolute_two_joints_two_links")
  sdformat_test_files_get_model_sdf("path_to_sdf_joint_screw" "joint_screw")
  sdformat_test_files_get_model_sdf("path_to_sdf_joint_universal" "joint_universal")
  sdformat_test_files_get_model_sdf("path_to_sdf_link_inertia" "link_inertia")
  sdformat_test_files_get_model_sdf("path_to_sdf_link_light_point" "link_light_point")
  sdformat_test_files_get_model_sdf("path_to_sdf_link_multiple_collisions" "link_multiple_collisions")
  sdformat_test_files_get_model_sdf("path_to_sdf_link_multiple_visuals" "link_multiple_visuals")
  sdformat_test_files_get_model_sdf("path_to_sdf_link_sensor_imu" "link_sensor_imu")
  sdformat_test_files_get_model_sdf("path_to_sdf_material_blinn_phong" "material_blinn_phong")
  sdformat_test_files_get_model_sdf("path_to_sdf_material_dynamic_lights" "material_dynamic_lights")
  sdformat_test_files_get_model_sdf("path_to_sdf_model_two_models" "model_two_models")
  sdformat_test_files_get_model_sdf("path_to_sdf_model_zero_models" "model_zero_models")
  sdformat_test_files_get_model_sdf("path_to_sdf_pose_chain" "pose_chain")
  sdformat_test_files_get_model_sdf("path_to_sdf_pose_collision" "pose_collision")
  sdformat_test_files_get_model_sdf("path_to_sdf_pose_collision_in_frame" "pose_collision_in_frame")
  sdformat_test_files_get_model_sdf("path_to_sdf_pose_inertial" "pose_inertial")
  sdformat_test_files_get_model_sdf("path_to_sdf_pose_inertial_in_frame" "pose_inertial_in_frame")
  sdformat_test_files_get_model_sdf("path_to_sdf_pose_joint" "pose_joint")
  sdformat_test_files_get_model_sdf("path_to_sdf_pose_joint_all" "pose_joint_all")
  sdformat_test_files_get_model_sdf("path_to_sdf_pose_joint_in_frame" "pose_joint_in_frame")
  sdformat_test_files_get_model_sdf("path_to_sdf_pose_link" "pose_link")
  sdformat_test_files_get_model_sdf("path_to_sdf_pose_link_all" "pose_link_all")
  sdformat_test_files_get_model_sdf("path_to_sdf_pose_link_in_frame" "pose_link_in_frame")
  sdformat_test_files_get_model_sdf("path_to_sdf_pose_model" "pose_model")
  sdformat_test_files_get_model_sdf("path_to_sdf_pose_visual" "pose_visual")
  sdformat_test_files_get_model_sdf("path_to_sdf_pose_visual_in_frame" "pose_visual_in_frame")
  configure_file("test/sdf_paths.hpp.in" "${CMAKE_CURRENT_BINARY_DIR}/generated_includes/sdf_paths.hpp" @ONLY)

  ament_add_gtest(sdf_geometry_tests "test/geometry_tests.cpp")
  target_link_libraries(sdf_geometry_tests sdformat_urdf)
  target_include_directories(sdf_geometry_tests PRIVATE
    "${CMAKE_CURRENT_SOURCE_DIR}/test/include"
    "${CMAKE_CURRENT_BINARY_DIR}/generated_includes")

  ament_add_gtest(sdf_graph_tests "test/graph_tests.cpp")
  target_link_libraries(sdf_graph_tests sdformat_urdf)
  target_include_directories(sdf_graph_tests PRIVATE
    "${CMAKE_CURRENT_SOURCE_DIR}/test/include"
    "${CMAKE_CURRENT_BINARY_DIR}/generated_includes")

  ament_add_gtest(sdf_joint_tests "test/joint_tests.cpp")
  target_link_libraries(sdf_joint_tests sdformat_urdf)
  target_include_directories(sdf_joint_tests PRIVATE
    "${CMAKE_CURRENT_SOURCE_DIR}/test/include"
    "${CMAKE_CURRENT_BINARY_DIR}/generated_includes")

  ament_add_gtest(sdf_link_tests "test/link_tests.cpp")
  target_link_libraries(sdf_link_tests sdformat_urdf)
  target_include_directories(sdf_link_tests PRIVATE
    "${CMAKE_CURRENT_SOURCE_DIR}/test/include"
    "${CMAKE_CURRENT_BINARY_DIR}/generated_includes")

  ament_add_gtest(sdf_material_tests "test/material_tests.cpp")
  target_link_libraries(sdf_material_tests sdformat_urdf)
  target_include_directories(sdf_material_tests PRIVATE
    "${CMAKE_CURRENT_SOURCE_DIR}/test/include"
    "${CMAKE_CURRENT_BINARY_DIR}/generated_includes")

  ament_add_gtest(sdf_model_tests "test/model_tests.cpp")
  target_link_libraries(sdf_model_tests sdformat_urdf)
  target_include_directories(sdf_model_tests PRIVATE
    "${CMAKE_CURRENT_SOURCE_DIR}/test/include"
    "${CMAKE_CURRENT_BINARY_DIR}/generated_includes")

  ament_add_gtest(sdf_pose_tests "test/pose_tests.cpp")
  target_link_libraries(sdf_pose_tests sdformat_urdf)
  target_include_directories(sdf_pose_tests PRIVATE
    "${CMAKE_CURRENT_SOURCE_DIR}/test/include"
    "${CMAKE_CURRENT_BINARY_DIR}/generated_includes")

endif()

ament_package()

=== debian/changelog ===
ros-rolling-sdformat-urdf (0.1.0-1focal) focal; urgency=high

  * Initial urdf parser plugin that parses sdformat (#1 <https://github.com/ros/sdformat_urdf/issues/1>)
  * Contributors: Shane Loretz, Addisu Z. Taddese, Steve Peters, Chris Lalancette, Eric Cousineau

 -- Shane Loretz <sloretz@osrfoundation.org>  Mon, 02 Nov 2020 08:00:00 -0000

=== debian/control ===
Source: ros-rolling-sdformat-urdf
Section: misc
Priority: optional
Maintainer: Shane Loretz <sloretz@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), libsdformat9-dev, liburdfdom-headers-dev, ros-rolling-ament-cmake-gtest, ros-rolling-ament-cmake-ros, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-pluginlib, ros-rolling-sdformat-test-files, ros-rolling-tinyxml2-vendor, ros-rolling-urdf, ros-rolling-urdf-parser-plugin, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-sdformat-urdf
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libsdformat9-dev, ros-rolling-ament-cmake-ros, ros-rolling-tinyxml2-vendor, ros-rolling-urdf, ros-rolling-urdf-parser-plugin, ros-rolling-ros-workspace
Description: URDF plugin to parse SDFormat XML into URDF C++ DOM objects.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-sdformat-urdf//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-sdformat-urdf 1.0.1

=== debian/changelog ===
ros-rolling-sdformat-urdf (1.0.1-2jammy) jammy; urgency=high

  * Remove version requirement on sdformat_test_files (#15 <https://github.com/ros/sdformat_urdf/issues/15>)
  * Contributors: Shane Loretz

 -- Shane Loretz <sloretz@osrfoundation.org>  Tue, 21 Jun 2022 07:00:00 -0000

ros-rolling-sdformat-urdf (1.0.0-2jammy) jammy; urgency=high

  * Support for universal and ball joint as floating joints #13 <https://github.com/ros/sdformat_urdf/issues/13>
  * Support SDFormat 12 (#12 <https://github.com/ros/sdformat_urdf/issues/12>)
  * Use urdfdom_headers::urdfdom_headers (#5 <https://github.com/ros/sdformat_urdf/issues/5>, #6 <https://github.com/ros/sdformat_urdf/issues/6>))
  * Contributors: Dharini Dutia, Louise Poubel, Shane Loretz

 -- Shane Loretz <sloretz@osrfoundation.org>  Tue, 21 Jun 2022 07:00:00 -0000

ros-rolling-sdformat-urdf (0.1.0-2jammy) jammy; urgency=high

  * Initial urdf parser plugin that parses sdformat (#1 <https://github.com/ros/sdformat_urdf/issues/1>)
  * Contributors: Shane Loretz, Addisu Z. Taddese, Steve Peters, Chris Lalancette, Eric Cousineau

 -- Shane Loretz <sloretz@osrfoundation.org>  Mon, 02 Nov 2020 08:00:00 -0000

=== debian/control ===
Source: ros-rolling-sdformat-urdf
Section: misc
Priority: optional
Maintainer: Shane Loretz <sloretz@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), libsdformat12-dev, liburdfdom-headers-dev, ros-rolling-ament-cmake-gtest <!nocheck>, ros-rolling-ament-cmake-ros, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-pluginlib, ros-rolling-rcutils, ros-rolling-sdformat-test-files <!nocheck>, ros-rolling-tinyxml2-vendor, ros-rolling-urdf, ros-rolling-urdf-parser-plugin, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-sdformat-urdf
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libsdformat12-dev, liburdfdom-headers-dev, ros-rolling-ament-cmake-ros, ros-rolling-pluginlib, ros-rolling-rcutils, ros-rolling-tinyxml2-vendor, ros-rolling-urdf, ros-rolling-urdf-parser-plugin, ros-rolling-ros-workspace
Description: URDF plugin to parse SDFormat XML into URDF C++ DOM objects.

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
